<?php

    defined( 'BASE_DIR' ) OR die( 'No direct access allowed.' );

    class przykladowymodul extends Controller {

        /**
         * obsluga kontrolera w przypadku wejścia na adres nazwastrony.php/admin/?page=przykladowymodul.php
         */
        public function index() {
            global $komunikaty;
			
			/**
			 * obsługa zmiennych
			 */
			if( isset( $_POST ) && !empty( $_POST ) ) {
				foreach( $_POST as $klucz => $zmienna ) {
					Config::set( $klucz, $zmienna, 'przykladowymodul' );
				}
				if( Config::save() ) {
					$komunikaty->Set( 'main', GLOBAL_DATA_SAVED );
				}
				else {
					$komunikaty->Set( 'main', GLOBAL_DATA_ERROR );
				}
			}
			
			/** 
			 * wydruk komunikatów
			 */
			echo $komunikaty->Show( 'main' );
            
			/**
			 * utworzenie i wydruk widoku
			 * dla dobrej obsługi modułu należy do nazwy widoku dodać przedrostek przykladowymodul. - dzięki czemu system nie nadpisze wyboru widoku standardowym pobranym z katalogu /admin/view
			 */
            $view = View::factory( 'przykladowymodul.widok1' );
            $view->set( 'konfiguracja_1', Config::get( 'zmienna_1', 'przykladowymodul' ) );
            $view->set( 'konfiguracja_2', Config::get( 'zmienna_2', 'przykladowymodul' ) );
            echo $view->ctable( 'Konfiguracja modułu' );
        }
		
		/**
         * obsluga kontrolera w przypadku wejścia na adres nazwastrony.php/admin/?page=przykladowymodul.przyklad.php
		 * W przypadku wstawienia pomiedzy nazwa modułu a rozszerzeniem dodatkowego napisu wykona się odpowiednia metoda klasy 
         */
		public function przyklad() {
            global $sql;
			
			/**
			 * przygotowanie danych dla widoku
			 */
			if( $sql->Query( 'SELECT `id` FROM `produkty` LIMIT 10' ) > 0 ) {
				$produkty = $sql->GetResult();
			}
			else {
				$produkty = array();
			}
            
			/**
			 * utworzenie i wydruk widoku
			 */
            $view = View::factory( 'przykladowymodul.widok2' );
            $view->set( 'wybrane_produkty', $produkty );
            echo $view->ctable( 'Wybrane produkty' );
        }
		
		/**
		 * trzecia, bardziej zaawansowana składnia modulu
		 */
		public function przyklad2() {
			global $site_no;
			
			$objPList = new GenericList( 'produkty', 'Product', $_SESSION['perpage'] );
			$objPArr = $objDPDList->GetAllByQuery( 'ORDER BY `id` ASC', $site_no );
            
			/**
			 * utworzenie i wydruk widoku
			 */
            $view = View::factory( 'przykladowymodul.widok3' );
            $view->set( 'objPList', $objPList );
			$view->set( 'objPArr', $objPArr );
            echo $view->ctable( 'Wybrane produkty' );
        }
    }