<?php

	defined( 'BASE_DIR' ) OR die( 'No direct access allowed.' );

	Event::add( 'system.display', 'przykladowa_obsluga_zdarzenia' );
	
	// dodanie obslugi znacznika [%przykladowy_tag%]
	function partner_template() {
		if( strpos( Event::$data, template_decore( 'przykladowy_tag' ) !== FALSE ) {
			
			$konfiguracja_1 = Config::get( 'zmienna_1', 'przykladowymodul' );
			$konfiguracja_2 = Config::get( 'zmienna_2', 'przykladowymodul' );
			
			// wyszukuje w aktualnym szablonie pliku html, można wykorzystać klasę Template
			$template = load_template( 'przykladowy_html.html' );
			
			$template_tmp .= template_replace( $template, array(
				template_decore( 'konfiguracja_1' ) => $konfiguracja_1,
				template_decore( 'konfiguracja_2' ) => $konfiguracja_2,
			), array(
				// obsluga znacznika <konfiguracja></konfiguracja>
				template_preg_decore( 'konfiguracja' ) => !empty( $konfiguracja_1 ) || !empty( $konfiguracja_2 ) ? '$1' : '',
			) );
			
			Event::$data = str_replace( template_decore( 'przykladowy_tag' ), $template_tmp, Event::$data );
		}
	}